--!parent
--!encoding=utf-8

--****************************************************************************
-- LSW CORE LIB: MULTITOUCH
--
-- @author Valentin Schmidt
-- @version 0.1
-- @requires xtra("MultiTouch")
--****************************************************************************

property $

property ancestor
property _target

----------------------------------------
-- @constructor
----------------------------------------
on new (me, callbackTarget)
	$.loadXtras(me.libdir, ["MultiTouch.x32"], [])
	
	$.import("detacher")
	
	if voidP(callbackTarget) then callbackTarget = _movie	
	me._target = callbackTarget
	me.ancestor = xtra("MultiTouch").new(me)

	me._loadConstants()

	return me
end

----------------------------------------
-- 
----------------------------------------
on _loadConstants (me)
	me[#GC_ALLGESTURES] = 1
	
	me[#GC_ZOOM] = 1
	
	me[#GC_PAN] = 1
	me[#GC_PAN_WITH_SINGLE_FINGER_VERTICALLY] = 2
	me[#GC_PAN_WITH_SINGLE_FINGER_HORIZONTALLY] = 4
	me[#GC_PAN_WITH_GUTTER] = 8
	me[#GC_PAN_WITH_INERTIA] = 16
	
	me[#GC_ROTATE] = 1
	
	me[#GC_TWOFINGERTAP] = 1
	
	me[#GC_PRESSANDTAP] = 1
	
	me[#GF_BEGIN] = 1 --A gesture is starting.
	me[#GF_INERTIA] = 2 -- A gesture has triggered inertia.
	me[#GF_END] = 4 -- A gesture has finished.
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on touchStart (me, touchEventID, touchPoint)
	$.detacher.detach(#touchStart, me._target, touchEventID, touchPoint)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on touchEnd (me, touchEventID, touchPoint)
	$.detacher.detach(#touchEnd, me._target, touchEventID, touchPoint)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on touchMove (me, touchEventID, touchPoint)
	$.detacher.detach(#touchMove, me._target, touchEventID, touchPoint)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on touchCancel (me, touchEventID, touchPoint)
	$.detacher.detach(#touchCancel, me._target, touchEventID, touchPoint)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on gestureZoom (me, flags, args, p)
	$.detacher.detach(#gestureZoom, me._target, flags, args, p)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on gesturePan (me, flags, args, p)
	$.detacher.detach(#gesturePan, me._target, flags, args, p)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on gestureRotate (me, flags, rot, p)
	$.detacher.detach(#gestureRotate, me._target, flags, rot, p)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on gestureTwoFingerTap (me, flags, args, p)
	$.detacher.detach(#gestureTwoFingerTap, me._target, flags, args, p)
end

----------------------------------------
-- @xtraCallback
----------------------------------------
on gesturePressAndTap (me, flags, args, p)
	$.detacher.detach(#gesturePressAndTap, me._target, flags, args, p)
end
