--!parent
--!encoding=utf-8

--****************************************************************************
-- Implements a simple button that responds to TAP gestures. Emits #tap.
--
-- @author Valentin Schmidt
-- @version 0.1
--****************************************************************************

global $
global gGestureRecognizer

property ancestor
property _sprite

----------------------------------------
--
----------------------------------------
on new (me, spriteRef)
	me.ancestor = $.include("resources\pattern_observer.ls").new(#tap)
	me._sprite = spriteRef
	gGestureRecognizer.registerEvent(#tap, me._sprite)
	return me
end

----------------------------------------
--
----------------------------------------
on tap (me, p)
	if not p.inside(me._sprite.rect) then return
	me._sprite.member.bgColor = rgb(160,160,160)
	_movie.updateStage()

	-- delay tap to allow visual feeback
	timeout().new("__TAP__", 150, #_tap, me)
	return TRUE
end

----------------------------------------
--
----------------------------------------
on _tap (me, t)
	t.forget()
	me._sprite.member.bgColor = rgb(230,230,230)
	_movie.updateStage()
	me._emit(#tap)
end

----------------------------------------
--
----------------------------------------
--on mouseUp me
--	me._emit(#tap)
--end
