--!parent
--!encoding=utf-8

global gGestureRecognizer

property _sprite

property _rect_reset

-- pan
property _is_pan

-- pinch
property _is_pinch
property _center_point_pinch
property _data_pinch
property _keep_ratio

-- rotate
property _is_rotate
property _angle_start
property _center_point_rotate

property MIN_WIDTH
property MIN_HEIGHT

----------------------------------------
--
----------------------------------------
on new (me, spriteRef)
	me._sprite = spriteRef
	me._rect_reset = me._sprite.rect

	MIN_WIDTH = 300
	MIN_HEIGHT = 300

	me._keep_ratio = TRUE

	gGestureRecognizer.registerEvent(#tap, me._sprite)
	gGestureRecognizer.registerEvent(#pan, me._sprite)
	gGestureRecognizer.registerEvent(#pinch, me._sprite)
	gGestureRecognizer.registerEvent(#rotate, me._sprite)

	return me
end

----------------------------------------
--
----------------------------------------
on reset (me)
	me._sprite.rotation = 0
	me._sprite.rect = me._rect_reset
end

----------------------------------------
--
----------------------------------------
on panStart (me, p)
	--put "panStart", p
	me._is_pan = p.inside(me._sprite.rect)

	-- put this sprite on top
	others = []
	sendAllSprites(#changeTopSprite, me._sprite, others)
	me._sprite.locZ = others.count+1
	gGestureRecognizer.updateLocZ()

	return me._is_pan
end if

----------------------------------------
--
----------------------------------------
on pan (me, point_last, point_now)
	--put "pan", point_last, point_now
	if me._is_pan then
		me._sprite.loc = me._sprite.loc + point_now - point_last
		return TRUE
	end if
end

----------------------------------------
--
----------------------------------------
on panStop (me)
	--put "panStop"
	if me._is_pan then
		me._is_pan = FALSE
		return TRUE
	end if
end

----------------------------------------
--
----------------------------------------
on pinchStart (me, p1, p2)
	--put "pinchStart", p1, p2
	me._is_pinch = (p1.inside(me._sprite.rect) and p2.inside(me._sprite.rect))
	if me._is_pinch then
		me._center_point_pinch = (p1+p2)/2. -- - point(me._sprite.left, me._sprite.top)
		--put "center_point", me._center_point_pinch

		dx1 = me._sprite.left - me._center_point_pinch.locH -- neg
		dy1 = me._sprite.top - me._center_point_pinch.locV -- neg
		dx2 = me._sprite.right  - me._center_point_pinch.locH
		dy2 = me._sprite.bottom - me._center_point_pinch.locV
		me._data_pinch = [dx1, dy1, dx2, dy2]

		-- put this sprite on top
		others = []
		sendAllSprites(#changeTopSprite, me._sprite, others)
		me._sprite.locZ = others.count+1
		gGestureRecognizer.updateLocZ()
	else
		me._sprite.locZ = me._sprite.spriteNum
	end if
	return me._is_pinch
end

----------------------------------------
--
----------------------------------------
on pinch (me, scale_x, scale_y)
	--put "pinch", scale_x, scale_y
	if not me._is_pinch then return

	scale_x = max(scale_x, MIN_WIDTH/(me._data_pinch[3]-me._data_pinch[1]))
	scale_y = max(scale_y, MIN_HEIGHT/(me._data_pinch[4]-me._data_pinch[2]))

--	if me._keep_ratio then
		scale_x = max(scale_x, scale_y)
		scale_y = scale_x
--	end if

	me._sprite.rect = rect(\
		me._center_point_pinch.locH + me._data_pinch[1] * scale_x,\
		me._center_point_pinch.locV + me._data_pinch[2] * scale_y,\
		me._center_point_pinch.locH + me._data_pinch[3] * scale_x,\
		me._center_point_pinch.locV + me._data_pinch[4] * scale_y)
end

----------------------------------------
--
----------------------------------------
on pinchStop (me)
	--put "pinchStop"
	me._is_pinch = FALSE
end

----------------------------------------
--
----------------------------------------
on rotateStart (me, p1)
	me._is_rotate = (p1.inside(me._sprite.rect))
	if me._is_rotate then
		-- change regPoint, keep current rect
		p = me._sprite.mapStageToMember(p1)
		if ilk(p)<>#point then -- ???
			me._is_rotate = FALSE
			return FALSE
		end if
		r = me._sprite.rect
		me._sprite.member.regPoint = p
		me._sprite.rect = r

		me._angle_start = me._sprite.rotation
		me._center_point_rotate = p1

	end if
	return me._is_rotate
end

----------------------------------------
--
----------------------------------------
on rotate (me, angle)
	if not me._is_rotate then return
	me._sprite.rotation = me._angle_start + angle
end

----------------------------------------
--
----------------------------------------
on rotateStop (me)
	me._is_rotate = FALSE
end

----------------------------------------
--
----------------------------------------
on tap (me, p)
	is_tap = p.inside(me._sprite.rect)
	if is_tap then
		-- put this sprite on top
		others = []
		sendAllSprites(#changeTopSprite, me._sprite, others)
		me._sprite.locZ = others.count+1
		gGestureRecognizer.updateLocZ()
	end if
	return is_tap
end

----------------------------------------
--
----------------------------------------
on doubleTap (me, p)
	--put "doubleTap", p
	is_tap = p.inside(me._sprite.rect)
	if is_tap then me.reset()
	return is_tap
end

----------------------------------------
--
----------------------------------------
on changeTopSprite (me, newTopSprite, others)
	if me._sprite<>newTopSprite then
		others.add(me._sprite)
		if me._sprite.locZ>newTopSprite.locZ then
			me._sprite.locZ = me._sprite.locZ-1
		end if
	end if
end
