--!parent
--!encoding=utf-8

--****************************************************************************
-- [View] Base class that implements observer pattern based on #connect and #_emit
--
-- @author Valentin Schmidt
-- @version 1.0
--****************************************************************************

property _observers

----------------------------------------
--
----------------------------------------
on new (me)
	me._observers = [:]
	repeat with i = 2 to paramCount()
		me._observers[param(i)] = []
	end repeat
	return me
end

----------------------------------------
--
----------------------------------------
on connect (me, event, cbHandler, cbTarget)
	if voidP(cbTarget) then cbTarget = _movie
	me._observers[event].add([cbHandler, cbTarget])
end

----------------------------------------
--
----------------------------------------
on disconnect (me, event, cbHandler, cbTarget)
	if voidP(cbHandler) then
		-- disconnect all
		me._observers[event] = []
	else
		if voidP(cbTarget) then cbTarget = _movie
		repeat with h in me._observers[event]
			if h[1]=cbHandler and h[2]=cbTarget then
				me._observers[event].deleteOne(h)
				exit repeat
			end if
		end repeat
	end if
end

----------------------------------------
--
----------------------------------------
on _emit (me, event, p1, p2, p3, p4)
	repeat with h in me._observers[event]
		call(h[1], h[2], p1, p2, p3, p4)
	end repeat
end
