--!parent
--!encoding=utf-8

--****************************************************************************
-- [View] Simple vertical slider that emits #valueChanged with values in range -1.0 to 1.0
--
-- @author Valentin Schmidt
-- @version 1.0
--****************************************************************************

global $

property ancestor
property _sprite
property _panID
property _touchPointLastY
property _minY
property _maxY

----------------------------------------
--
----------------------------------------
on new (me, spriteRef)
	me.ancestor = $.include("resources\pattern_observer.ls").new(#valueChanged)

	me._sprite = spriteRef
	me._panID = VOID

	me._minY = 50
	me._maxY = _movie.stage.rect.height-250
	return me
end

----------------------------------------
--
----------------------------------------
on touchStart (me, touchEventID, touchPoint)
	if touchPoint.inside(me._sprite.rect) then
		me._panID = touchEventID
		me._touchPointLastY = touchPoint.locV
		stopEvent()
	end if
end if

----------------------------------------
--
----------------------------------------
on touchMove (me, touchEventID, touchPoint)
	if touchEventID<>me._panID then return
	stopEvent()
	y = me._sprite.locV + touchPoint.locV - me._touchPointLastY
	y = max(min(y, me._maxY), me._minY)
	me._sprite.locV = y
	me._touchPointLastY = touchPoint.locV

	-- emit value in range -1 .. 1
	v = 1 - 2*float(y-me._minY)/(me._maxY-me._minY)
	me._emit(#valueChanged, me._sprite.spriteNum, v)
end
